draw_th0:
  xor eax,eax
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0
ret

draw_th1:
  mov eax,1
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,1
ret
draw_thread:
    push   ebp
    mov    ebp,esp
    sub    esp,256
    and    ebp,-16

    .thread_no equ dword[ebp-4]
    .x_min     equ word[ebp-6]
    .x_max     equ word[ebp-8]
    .y_min     equ word[ebp-10]
    .y_max     equ [ebp-12]
    .third_p_index  equ dword[ebp-16]
    .second_p_index equ dword[ebp-20]
    .first_p_index  equ dword[ebp-24]
   .zz3f equ dword[ebp-28]
   .zz2f equ dword[ebp-32]
   .zz1f equ [ebp-36]
   .xy3  equ ebp-40
   .xy2  equ ebp-44
   .xy1  equ ebp-48
   .zz3  equ [ebp-52]
   .zz2  equ [ebp-54]
   .zz1  equ [ebp-56]
   .x_temp_var equ dword [ebp-112]
   .y_temp_var equ dword [ebp-116]
   .counter    equ dword [ebp-120]
   .xx1        equ word[ebp-122]
   .xx2        equ word[ebp-124]
   .xx3        equ word[ebp-126]
   .yy1        equ word[ebp-128]
   .yy2        equ word[ebp-130]
   .yy3        equ word[ebp-132]



    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    mov    .x_min,0
    push   word[xres_var]
    pop    .x_max

    mov   esi,triangles 	   ; draw triangles
    movzx ecx,[triangles_count_var]
.draw_triangle:
    push  ecx
    push  esi
    fninit
    movzx edx,word[esi]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .first_p_index,edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp .xx1
    movzx eax,.xx1
    shl   eax,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp .yy1
    mov   ax,.yy1
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fstp  dword .zz1f
					; z coord - skip
    movzx edx,word[esi+2]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .second_p_index,edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp .xx2
    movzx ebx,.xx2
    shl   ebx,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp .yy2
    mov   bx,.yy2
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fstp  .zz2f

    movzx edx,word[esi+4]
    shl   edx,2
    lea   edx,[edx*3]
    mov   .third_p_index,edx
    add   edx,points_rotated
    fld   dword[edx]
    fmul  [scale]
    fiadd word[xxadd]
    fistp .xx3
    movzx ecx,.xx3
    shl   ecx,16
    fld   dword[edx+4]
    fmul  [scale]
    fiadd [yyadd]
    fistp .yy3
    mov   cx,.yy3
    fld   dword[edx+8]
    fmul  [scale]
    fiadd [zzadd]
    fstp  .zz3f

;    push     ebp
;    push     esi


     mov     edx,.first_p_index
     mov     esi,.second_p_index
     mov     edi,.third_p_index
     movups  xmm0,[edx+points_normals_rotated]
     movups  xmm1,[esi+points_normals_rotated]
     movups  xmm2,[edi+points_normals_rotated]
     andps   xmm0,[mask_h_zero]
     andps   xmm1,[mask_h_zero]
     andps   xmm2,[mask_h_zero]
     mov     edx,1.0
     movd    xmm3,edx
     pshufd  xmm3,xmm3,11001111b
     movups  xmm4,.zz1f
     andps   xmm4,[mask_h_zero]
     xorps   xmm6,xmm6
     movq    xmm5,.y_max
     punpcklwd xmm5,xmm6
; is	  lo -> hi     ymax, ymin, xmax, xmin
; will be lo -> hi     ymin, ymax, xmin, xmax
     pshufd  xmm5,xmm5,10110001b
     mov     edx, 0 shl 16 + 64
     mov     esi,127 shl 16 + 127
     mov     edi,127 shl 16 + 0
     movd    xmm6,edx
     movd    xmm7,esi
     movlhps xmm6,xmm7
     movd    xmm7,edi
     pslldq  xmm7,4
     por     xmm6,xmm7
     movzx   edx,word[xres_var]
     movd    xmm7,edx
     pslldq  xmm7,12
     por     xmm6,xmm7

     mov     edi,[screen_ptr]	; screen buffer
     mov     esi,[Zbuffer_ptr]
     mov     edx,texmap

     call    r_phg_bi_fil

 .end_draw:
    pop    esi
    pop    ecx
    add    esi,6
    sub    ecx,1
    jnz    .draw_triangle

    add esp,256
    pop ebp
ret
